

#include <gtkmm.h>
#include "MGCanvas.h"
#include "myx_gc_figure.h"
#include "myx_gc_model.h"


CLayer *paperLayer;




void make_something(CGenericCanvas *canvas)
{
  CFigure *paper, *obj[5];
  
  paperLayer= canvas->CreateLayer("Paper", GC_LAYER_NORMAL);

  paper= canvas->GetModel()->CreateFigure("paper", 0);
  paperLayer->CreateInstance(paper);
  paper->Scale(10,10,1,false);
  
  if ( canvas->AddTemplatesFromFile("./xml/layout.db.xml") != GC_NO_ERROR)
    g_message("error loading layout ifno");

  
  obj[0]= canvas->GetModel()->CreateFigure("db.Catalog", 0);
  obj[1]= canvas->GetModel()->CreateFigure("db.Schema", 0);
  obj[2]= canvas->GetModel()->CreateFigure("db.Table", 0);
  obj[3]= canvas->GetModel()->CreateFigure("db.Column", 0);
  obj[4]= canvas->GetModel()->CreateFigure("db.StructuredDatatype", 0);
  obj[5]= canvas->GetModel()->CreateFigure("db.SimpleDatatype", 0);
  
  
  for (int i=0; i < 10; i++)
  {
    int o= rand()%6;
    
    obj[o]->Scale(20,20,1,false);
    obj[o]->Translate(10+rand()%500,10+rand()%500, 0, false);
    
    paperLayer->CreateInstance(obj[o]);
  }
}



int main(int argc, char **argv)
{
  Gtk::Main main(argc, argv);
  Gtk::Window win(Gtk::WINDOW_TOPLEVEL);
  MGCanvas canvas;
  
  win.add(canvas);
  
  canvas.show();

  win.show();
  
  make_something(canvas.canvas());

  main.run();
  
  return 0;
}
