unit XGrtShell;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, ComCtrls, TntComCtrls,
  TntForms, ExtCtrls, TntExtCtrls, ImgList, Menus, TntMenus,
  StdCtrls, TntStdCtrls, TntSysUtils, StrUtils, TntDialogs,
  TntClipbrd, TntClasses,
  UniCodeEditor, UniCodeConsole, VirtualTrees,
  myx_public_interface, myx_grt_public_interface,
  PNGImage, AuxFuncs, ApplicationDataModule,
  Grt, GrtObjectTree,
  Options;

type
  PGrtObjInspectorData = ^TGRTObjInspectorData;
  TGRTObjInspectorData = record
    Value: Pointer;
  end;

  GRTStructTreeDataType =
  (
    GrtStPackage, GrtStStruct, GrtStMember
  );

  FGrtStructTreeData = ^TGrtStructTreeData;
  TGrtStructTreeData = record
    DataType: GRTStructTreeDataType;
    Struct: PMYX_GRT_STRUCT;
    Member: PMYX_GRT_STRUCT_MEMBER;
    PackageName: WideString;
  end;


  GRTModuleTreeDataType =
  (
    GrtMtModule, GrtMtFunction
  );

  FGrtModuleTreeData = ^TGRTModuleTreeData;
  TGRTModuleTreeData = record
    DataType: GRTModuleTreeDataType;
    Module: PMYX_GRT_MODULE;
    ModuleFunction: PMYX_GRT_FUNCTION;
  end;

  GrtStructSortType = (
    GrtStSTName,
    GrtStSTHierachy,
    GrtStSTPackage
  );

  TXGrtShellForm = class(TTntForm)
    TntStatusBar1: TTntStatusBar;
    CommandLinePnl: TTntPanel;
    CommandLineUCC: TUniCodeConsole;
    ObjClassPnl: TTntPanel;
    TntSplitter2: TTntSplitter;
    ObjInspectorPnl: TTntPanel;
    ObjInspectorTree: TVirtualStringTree;
    ObjInspectorLookupPnl: TTntPanel;
    ObjectTreeLookup: TTntComboBox;
    TntMainMenu1: TTntMainMenu;
    FileMI: TTntMenuItem;
    HelpMI: TTntMenuItem;
    ExitMI: TTntMenuItem;
    CommandLineSplitter: TTntSplitter;
    RefreshMI: TTntMenuItem;
    TreeImageList: TImageList;
    ViewMI: TTntMenuItem;
    N1: TTntMenuItem;
    DisplayObjectValuesMI: TTntMenuItem;
    AboutMI: TTntMenuItem;
    SaveGRTEnvironmentMI: TTntMenuItem;
    OpenGRTEnvironmentMI: TTntMenuItem;
    N2: TTntMenuItem;
    N3: TTntMenuItem;
    ConvertGRTStructFileToJavaClassesMI: TTntMenuItem;
    SidebarPnl: TTntPanel;
    SidePageControl: TTntPageControl;
    ValuesTabsheet: TTntTabSheet;
    Structs: TTntTabSheet;
    FunctionsSheet: TTntTabSheet;
    LeftSpacerPnl: TTntPanel;
    RightSpacerPnl: TTntPanel;
    TopSpacerPnl: TTntPanel;
    ModulesTree: TVirtualStringTree;
    TntPanel1: TTntPanel;
    TntSplitter3: TTntSplitter;
    ShellPopupMenu: TTntPopupMenu;
    FontSizeMI: TTntMenuItem;
    FontSizeMediumMI: TTntMenuItem;
    FontSizeLargeMI: TTntMenuItem;
    FontSizeSmallMI: TTntMenuItem;
    TntLabel1: TTntLabel;
    ModuleNameLbl: TTntLabel;
    TntLabel2: TTntLabel;
    PathLbl: TTntLabel;
    TntLabel3: TTntLabel;
    ExtendsLbl: TTntLabel;
    TypeCaptionLbl: TTntLabel;
    ModuleTypeLbl: TTntLabel;
    StructsTree: TVirtualStringTree;
    TntPanel2: TTntPanel;
    TntShape1: TTntShape;
    TntPanel3: TTntPanel;
    InspectedObjectEd: TTntEdit;
    MainPnl: TTntPanel;
    TntPanel4: TTntPanel;
    MainPageControl: TTntPageControl;
    GtrShellSheet: TTntTabSheet;
    ScriptSheet: TTntTabSheet;
    TntPanel5: TTntPanel;
    TntPanel6: TTntPanel;
    UniCodeEdit1: TUniCodeEdit;
    StructPopupMenu: TTntPopupMenu;
    StructsOrderbyNameMI: TTntMenuItem;
    StructsOrderbyHierachyMI: TTntMenuItem;
    StructsOrderbyPackagesMI: TTntMenuItem;
    ObjInspectorTreePopupMenu: TTntPopupMenu;
    ObjInspectorCopyValueMI: TTntMenuItem;
    CurrentReverenceValuesMI: TTntMenuItem;
    GlobalObjTreePopupMenu: TTntPopupMenu;
    RemoveObjectMI: TTntMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    function CommandLineUCCIsMultilineCommand(Cmd: WideString; Key: Word;
      Shift: TShiftState): Boolean;
    procedure CommandLineUCCExecuteCommand(Cmd: WideString; Key: Word;
      Shift: TShiftState);

    procedure BuildObjTreeFromLookupSelection;
    procedure BuildObjTree(ObjectTreeRoot: WideString);

    procedure RefreshMIClick(Sender: TObject);

    procedure DisplayObjectValuesMIClick(Sender: TObject);
    procedure GRTObjTreeChange(Sender: TBaseVirtualTree;
      Node: PVirtualNode);

    procedure RefreshGRTObjInspector;
    procedure ObjInspectorTreeGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);

    procedure ExitMIClick(Sender: TObject);
    procedure AboutMIClick(Sender: TObject);
    procedure OpenGRTEnvironmentMIClick(Sender: TObject);
    procedure SaveGRTEnvironmentMIClick(Sender: TObject);
    procedure ConvertGRTStructFileToJavaClassesMIClick(Sender: TObject);

    procedure BuildModulesTree;
    procedure ModulesTreeGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure ModulesTreeAfterCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure ModulesTreeInitChildren(Sender: TBaseVirtualTree;
      Node: PVirtualNode; var ChildCount: Cardinal);
    procedure ModulesTreeInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure TntFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ModulesTreeDblClick(Sender: TObject);
    procedure ModulesTreeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FontSizeMIClick(Sender: TObject);
    procedure ModulesTreeChange(Sender: TBaseVirtualTree;
      Node: PVirtualNode);

    procedure BuildStructsTree;

    procedure StructsTreeAfterCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure StructsTreeInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure StructsTreeInitChildren(Sender: TBaseVirtualTree;
      Node: PVirtualNode; var ChildCount: Cardinal);
    procedure StructsTreeGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure ObjectTreeLookupCloseUp(Sender: TObject);
    procedure ObjectTreeLookupKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StructsTreeCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure StructsOrderbyNameMIClick(Sender: TObject);
    procedure StructsOrderbyHierachyMIClick(Sender: TObject);
    procedure StructPopupMenuPopup(Sender: TObject);
    procedure StructsOrderbyPackagesMIClick(Sender: TObject);
    procedure StructsTreeGetHint(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex;
      var LineBreakStyle: TVTTooltipLineBreakStyle;
      var HintText: WideString);
    procedure ObjInspectorTreeGetHint(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex;
      var LineBreakStyle: TVTTooltipLineBreakStyle;
      var HintText: WideString);
    function GetInspectorObjectText(Node: PVirtualNode; Column: TColumnIndex): WideString;
    procedure ModulesTreeCompareNodes(Sender: TBaseVirtualTree; Node1,
      Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);
    procedure CommandLineUCCDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure CommandLineUCCDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure ObjInspectorCopyValueMIClick(Sender: TObject);
    procedure CurrentReverenceValuesMIClick(Sender: TObject);
    procedure RemoveObjectMIClick(Sender: TObject);
  protected
    procedure OutputCommandLine(Text: WideString);

    procedure SetObjInspectorObject(ObjInspectorObject: Pointer);

    function GetGrt: TGrt;
    procedure SetSortStructsBy(SortStructsBy: GrtStructSortType);
  private
    { Private declarations }
    FGrt: TGrt;

    FTreeBtnOpenPNGImg,
      FTreeBtnClosedPNGImg: TPNGObject;

    FGrtValueDictPNGImg,
      FGrtValueListPNGImg,
      FGrtValueSimplePNGImg,
      FGrtValueStructPNGImg,
      FGrtModulePNGImg,
      FGrtFunctionPNGImg: TPNGObject;

    FOnlyObjectStructure: Boolean;

    FObjInspectorObject: Pointer;

    FSortStructsBy: GrtStructSortType;
  public
    { Public declarations }
    GrtObjectTree: TGrtObjectTree;

    property GrtP: TGrt read GetGrt;
    property ObjInspectorObject: Pointer read FObjInspectorObject write SetObjInspectorObject;    property SortStructsBy: GrtStructSortType read FSortStructsBy write SetSortStructsBy;

    function InitializeShell(ScriptFilename: WideString = '';
      Verbose: Boolean = False; RemoteDebug: Boolean = False;
      JvmLibrary: WideString = ''): TGrt;
  end;

var
  XGrtShellForm: TXGrtShellForm;

implementation

{$R *.dfm}

uses
  PNGTools;


// -----------------------------------------------------------------------------

function TXGrtShellForm.GetGrt: TGrt;

begin
  Result := FGrt;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.FormCreate(Sender: TObject);

begin
  InitForm(self);

  if (not (ApplicationDM.Options.RestoreWindowPos(self))) then
  begin
    if (Screen.Width >= 1024) then
    begin
      Width := 1024;
      Height := 768 - 48;

      Left := (Screen.Width + Width) div 2 - Width;
      Top := 0;
    end
    else
    begin
      Width := 800;
      Height := 572;

      Left := (Screen.Width + Width) div 2 - Width;
      Top := 0;

      WindowState := wsMaximized;
    end;
  end;

  Application.HintHidePause := MaxInt;

  MainPageControl.ActivePageIndex := 0;
  SidePageControl.ActivePageIndex := 0;
  ActiveControl := CommandLineUCC;

  FTreeBtnOpenPNGImg := LoadPNGImageFromResource('tree_button_open');
  FTreeBtnClosedPNGImg := LoadPNGImageFromResource('tree_button_closed');

  FGrtValueDictPNGImg := LoadPNGImageFromResource('grt_value_dict');
  FGrtValueListPNGImg := LoadPNGImageFromResource('grt_value_list');
  FGrtValueSimplePNGImg := LoadPNGImageFromResource('grt_value_simple');
  FGrtValueStructPNGImg := LoadPNGImageFromResource('grt_value_struct');
  FGrtModulePNGImg := LoadPNGImageFromResource('grt_module');
  FGrtFunctionPNGImg := LoadPNGImageFromResource('grt_function');

  FOnlyObjectStructure := True;

  // Create GRT Object Tree
  GrtObjectTree := TGrtObjectTree.Create(nil);
  GrtObjectTree.Parent := ObjClassPnl;
  GrtObjectTree.Align := alClient;
  GrtObjectTree.OnChange := GRTObjTreeChange;
  GrtObjectTree.PopupMenu := GlobalObjTreePopupMenu;
  GrtObjectTree.DisplayValueTypes := True;

  FObjInspectorObject := nil;

  FSortStructsBy := GrtStSTPackage;

  FontSizeMIClick(FontSizeMediumMI);

  ObjectTreeLookup.ItemIndex := 0;

  if (FileExists(MYXCommonOptions.UserDataDir+'mysqlgrt_history.xml')) then
  begin
    CommandLineUCC.ConsoleHistory := LoadAnsiTextFromFile(
      MYXCommonOptions.UserDataDir+'mysqlgrt_history.xml');
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.FormDestroy(Sender: TObject);

begin
  ApplicationDM.Options.AddWindowPos(self);

  SaveAnsiTextToFile(MYXCommonOptions.UserDataDir+'mysqlgrt_history.xml',
    CommandLineUCC.ConsoleHistory);

  GrtObjectTree.Free;

  // Free the GRT environment
  FGrt.Free;

  FTreeBtnOpenPNGImg.Free;
  FTreeBtnClosedPNGImg.Free;

  FGrtValueDictPNGImg.Free;
  FGrtValueListPNGImg.Free;
  FGrtValueSimplePNGImg.Free;
  FGrtValueStructPNGImg.Free;
  FGrtModulePNGImg.Free;
  FGrtFunctionPNGImg.Free;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.FormClose(Sender: TObject; var Action: TCloseAction);

begin
  //
end;

// -----------------------------------------------------------------------------

function TXGrtShellForm.InitializeShell(ScriptFilename: WideString;
  Verbose: Boolean; RemoteDebug: Boolean;
  JvmLibrary: WideString): TGrt;

begin
  // create the GRT environment
  try
    FGrt := TGrt.Create(CommandLineUCC, ScriptFilename,
      Verbose, RemoteDebug, JvmLibrary);
  except
    on x: Exception do
    begin
      ShowModalDialog(_('Application Exception'),
        _('The GRT Environment cannot be initialized.'),
        myx_mtError);

      DisableEnableControls(self, False);

      Application.Terminate;
    end;
  end;

  if (FGrt <> nil) then
  begin
    CommandLineUCC.ConsolePrompt := myx_grt_lua_shell_get_prompt(FGrt.PGrt);

    //OutputCommandLine('');
    CommandLineUCC.PrepareNextConsoleCommand;

    GrtObjectTree.Grt := FGrt;

    RefreshMIClick(self);
  end;

  Result := FGrt;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.OutputCommandLine(Text: WideString);

begin
  CommandLineUCC.AddOutput(#13#10 + Text);
end;

// -----------------------------------------------------------------------------

function TXGrtShellForm.CommandLineUCCIsMultilineCommand(Cmd: WideString;
  Key: Word; Shift: TShiftState): Boolean;

begin
  Result := False;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.CommandLineUCCExecuteCommand(Cmd: WideString;
  Key: Word; Shift: TShiftState);

var
  StartTime, EndTime: TDateTime;

begin
  StartTime := Now;

  CommandLineUCC.AddOutput(#13#10);
  if (FGrt.ExecuteModalShellFunction(Cmd) = MYX_GRT_SHELL_COMMAND_EXIT) then
    Application.Terminate;

  if (Shift = [ssCtrl]) then
  begin
    EndTime := Now;

    CommandLineUCC.AddOutput(_('Executed in ') +
      FormatDateTime('n:ss:zzz', EndTime - StartTime) + '.' + #13#10);
  end;

  CommandLineUCC.PrepareNextConsoleCommand;

  CommandLineUCC.ConsolePrompt := myx_grt_lua_shell_get_prompt(FGrt.PGrt);
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.BuildObjTreeFromLookupSelection;
begin
  if (ObjectTreeLookup.ItemIndex = 0) then
    BuildObjTree('/')
  else
    BuildObjTree(ObjectTreeLookup.Text);
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.RefreshMIClick(Sender: TObject);
begin
  BuildObjTreeFromLookupSelection;
  BuildModulesTree;
  BuildStructsTree;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.BuildObjTree(ObjectTreeRoot: WideString);


begin
  if (FGrt=nil) then
    Exit;

  InspectedObjectEd.Text := '';
  ObjInspectorTree.RootNodeCount := 0;

  GrtObjectTree.ObjectTreeRoot := ObjectTreeRoot;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.DisplayObjectValuesMIClick(Sender: TObject);

begin
  DisplayObjectValuesMI.Checked := Not(DisplayObjectValuesMI.Checked);

  GrtObjectTree.DisplayObjectValues := DisplayObjectValuesMI.Checked;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.GrtObjTreeChange(Sender: TBaseVirtualTree;
  Node: PVirtualNode);

var
  NodeData: PGrtObjTreeData;

begin
  NodeData := Sender.GetNodeData(Node);

  if (NodeData<>nil) and
    ((NodeData.ValueType=MYX_DICT_VALUE) or
    (NodeData.ValueType=MYX_LIST_VALUE)) then
  begin
    ObjInspectorObject := NodeData.Value;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.RefreshGRTObjInspector;

var
  PName: PChar;
  ValueType: MYX_GRT_VALUE_TYPE;
  DictStructName: WideString;

begin
  if (FObjInspectorObject<>nil) then
  begin
    ValueType := myx_grt_value_get_type(FObjInspectorObject);

    if ((ValueType = MYX_LIST_VALUE) or
      (ValueType = MYX_DICT_VALUE)) then
    begin
      if (ValueType = MYX_DICT_VALUE) then
      begin
        //Get struct name if there is any
        PName := _myx_grt_dict_struct_get_name(FObjInspectorObject);
        if (PName<>nil) then
          DictStructName := UTF8Decode(PName);

        //Get name
        PName := _myx_grt_dict_name_item_as_string(FObjInspectorObject);
        if (PName<>nil) then
          InspectedObjectEd.Text := UTF8Decode(PName) + ' (' +
            DictStructName + ')'
        else
          InspectedObjectEd.Text := 'DICT';
      end
      else
      begin
        //Get struct name if there is any
        PName := _myx_grt_list_content_get_struct_name(FObjInspectorObject);
        if (PName<>nil) then
          DictStructName := UTF8Decode(PName);

        InspectedObjectEd.Text := '[' +
          UTF8Decode(_myx_get_value_type_as_string(myx_grt_list_content_get_type(FObjInspectorObject)));

        if (DictStructName<>'') then
          InspectedObjectEd.Text := InspectedObjectEd.Text +
            ': '+DictStructName;

        InspectedObjectEd.Text := InspectedObjectEd.Text +
          ']';
      end;



      ObjInspectorTree.NodeDataSize:=sizeof(TGRTObjInspectorData);

      ObjInspectorTree.BeginUpdate;
      try
        ObjInspectorTree.Clear;

        if (ValueType = MYX_DICT_VALUE) then
          ObjInspectorTree.RootNodeCount := myx_grt_dict_item_count(ObjInspectorObject)
        else
          ObjInspectorTree.RootNodeCount := myx_grt_list_item_count(ObjInspectorObject);
      finally
        ObjInspectorTree.EndUpdate;
      end;
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.SetObjInspectorObject(ObjInspectorObject: Pointer);

begin
  FObjInspectorObject := ObjInspectorObject;

  RefreshGRTObjInspector;
end;

// -----------------------------------------------------------------------------

function TXGrtShellForm.GetInspectorObjectText(Node: PVirtualNode; Column: TColumnIndex): WideString;

var
  ValueType: MYX_GRT_VALUE_TYPE;

begin
  Result := '';

  if (FObjInspectorObject<>nil) then
  begin
    ValueType := myx_grt_value_get_type(FObjInspectorObject);

    if (ValueType = MYX_LIST_VALUE) then
    begin
      if (Integer(Node.Index)<myx_grt_list_item_count(FObjInspectorObject)) then
      begin
        if Column=0 then
          Result := '[' + IntToStr(Node.Index) + ']'
        else
          Result := myx_grt_value_formated_as_string(
            myx_grt_list_item_get(FObjInspectorObject, Node.Index));
      end;
    end
    else if (ValueType = MYX_DICT_VALUE) then
    begin
      if (Integer(Node.Index)<myx_grt_dict_item_count(FObjInspectorObject)) then
      begin
        if Column=0 then
          Result := UTF8Decode(_myx_grt_dict_item_key_by_index(FObjInspectorObject, Node.Index))
        else
          Result := myx_grt_value_formated_as_string(
            myx_grt_dict_item_value_by_index(FObjInspectorObject, Node.Index));
      end;
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ObjInspectorTreeGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);

begin
  CellText := GetInspectorObjectText(Node, Column);
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ObjInspectorTreeGetHint(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex;
  var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: WideString);

begin
  HintText := GetInspectorObjectText(Node, Column);
end;

// -----------------------------------------------------------------------------

{procedure TXGrtShellForm.PGrtObjTreePaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);

begin
  if (TextType=ttStatic) then
    TargetCanvas.Font.Color := clGray;
end;}

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ExitMIClick(Sender: TObject);

begin
  Close;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.AboutMIClick(Sender: TObject);

begin
  ShowModalDialog(_('MySQL GRT Environment GUI Shell'),
    _('MySQL Generic Runtime Environment GUI Shell 1.0 alpha'),
    myx_mtInformation, _('OK'));
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.OpenGRTEnvironmentMIClick(Sender: TObject);

var
  OpenDialog: TTntOpenDialog;
  Error: MYX_GRT_ERROR;
  NewRootValue: Pointer;

begin
  OpenDialog := TTntOpenDialog.Create(self);
  try
    OpenDialog.Filter := _('GRT Environment')+' (*.xml)|*.xml|'+
      _('Any file')+' (*.*)|*.*';

    if (OpenDialog.Execute) then
    begin
      NewRootValue := myx_grt_retrieve_from_file(OpenDialog.FileName);
      Error := myx_grt_set_root(FGrt.PGrt, NewRootValue);

      myx_grt_value_release(NewRootValue);

      if (Error<>MYX_GRT_NO_ERROR) then
      begin
        ShowModalDialog(_('Error'),
          Format(
            _('The following error occured while loading the ' +
              'snapshot. Error: %d.'), [Ord(Error)]),
          myx_mtError, _('Ok'));

        Exit;
      end;
    end;
  finally
    OpenDialog.Free;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.SaveGRTEnvironmentMIClick(Sender: TObject);
begin
  //
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ConvertGRTStructFileToJavaClassesMIClick(Sender: TObject);

var
  PStructs: Pointer;
  Path: WideString;
  Error: MYX_GRT_ERROR;
  OpenDialog: TTntOpenDialog;
  Package: WideString;

begin
  OpenDialog := TTntOpenDialog.Create(self);

  try
    OpenDialog.Filter := _('GRT Struct Definition')+' (*.xml)|*.xml|'+
      _('Any file')+' (*.*)|*.*';

    if (OpenDialog.Execute) then
    begin
      Package := ChangeFileExt(ExtractFileName(OpenDialog.FileName), '');

      if (Copy(Package, 1, 8)<>'structs_') then
        raise EInOutError.Create('The struct definition file must start with structs_');

      Package := AnsiReplaceStr(Copy(Package, 9, Length(Package)), '_', '.');

      PStructs := myx_grt_struct_load_list(OpenDialog.FileName, Addr(Error));
      try
        Path := ExtractFilePath(Application.ExeName)+'java\';
        ForceDirectories(Path);

        myx_grt_struct_export_java_classes(PStructs, Package, Path);
      finally
        myx_grt_structs_free(PStructs);
      end;
    end;
  finally
    OpenDialog.Free;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.BuildModulesTree;

begin
  if (FGrt=nil) then
    Exit;

  ModulesTree.BeginUpdate;
  try
    ModulesTree.Clear;
    ModulesTree.NodeDataSize:=sizeof(TGRTModuleTreeData);

    ModulesTree.RootNodeCount := myx_grt_module_get_count(FGrt.PGrt);
  finally
    ModulesTree.EndUpdate;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);

var
  NodeData: FGrtModuleTreeData;
  ParamTypes,
    ReturnType: WideString;

begin
  NodeData := Sender.GetNodeData(Node);

  if (NodeData.DataType = GrtMtModule) then
  begin
    if (TextType = ttNormal) then
      CellText := NodeData.Module.name;
  end
  else
    if (NodeData.DataType = GrtMtFunction) then
    begin
      if (TextType = ttNormal) then
      begin
        CellText := NodeData.ModuleFunction.name;

        ParamTypes := Trim(myx_grt_module_function_get_params(NodeData.ModuleFunction));

        if (ParamTypes<>'') then
          CellText := CellText + ' '+ParamTypes
        else
          CellText := CellText + ' ()';

        ReturnType := Trim(myx_grt_module_function_get_return_type(NodeData.ModuleFunction));
        if (ReturnType<>'') then
          CellText := CellText + ': '+ReturnType;

        CellText := CellText + ';';
      end;
    end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeAfterCellPaint(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  CellRect: TRect);

var
  NodeData: FGrtModuleTreeData;
  TxtRect: TRect;
  x: integer;
  Icon: TPNGObject;

begin
  if(Column=0)then
  begin
    NodeData := Sender.GetNodeData(Node);

    TxtRect:=Sender.GetDisplayRect(Node, Column, True);

    x:=TxtRect.Left-Sender.OffsetX;

    //Draw > / v
    if (Node.ChildCount>0) or (vsHasChildren in Node.States) then
    begin
      if(Sender.Expanded[Node])then
        FTreeBtnOpenPNGImg.Draw(TargetCanvas,
          Rect(x-16-12, CellRect.Top+4, x-16-4, CellRect.Top+16+4))
      else
        FTreeBtnClosedPNGImg.Draw(TargetCanvas,
          Rect(x-16-12, CellRect.Top+4, x-16-4, CellRect.Top+16+4))
    end;

    if (NodeData.DataType = GrtMtModule) then
      Icon := FGrtModulePNGImg
    else
      Icon := FGrtFunctionPNGImg;

    Icon.Draw(TargetCanvas,
        Rect(x-16, CellRect.Top+1, x, CellRect.Top+1+16));
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);

var
  NodeData, ParentNodeData: FGrtModuleTreeData;

begin
  NodeData := Sender.GetNodeData(Node);

  if (ParentNode = nil) then
  begin
    NodeData.DataType := GrtMtModule;

    NodeData.Module := myx_grt_module_get_by_index(FGrt.PGrt, Node.Index);

    Include(Node.States, vsHasChildren);
  end
  else
  begin
    ParentNodeData := Sender.GetNodeData(ParentNode);

    if (ParentNodeData.DataType = GrtMtModule) then
    begin
      NodeData.DataType := GrtMtFunction;

      NodeData.ModuleFunction := myx_grt_module_function_get_by_index(
        ParentNodeData.Module, Node.Index);
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeInitChildren(Sender: TBaseVirtualTree;
  Node: PVirtualNode; var ChildCount: Cardinal);

var
  NodeData: FGrtModuleTreeData;

begin
  NodeData := Sender.GetNodeData(Node);

  if (NodeData.DataType = GrtMtModule) then
    ChildCount := myx_grt_module_function_get_count(NodeData.Module)
  else
    ChildCount := 0;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.TntFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

begin
  if (Key = VK_F5) then
    RefreshMIClick(self);
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeDblClick(Sender: TObject);

var NodeData, ParentNodeData: FGrtModuleTreeData;
  Cmd: WideString;

begin
  if (Sender = ModulesTree) then
  begin
    NodeData := ModulesTree.GetNodeData(ModulesTree.FocusedNode);

    if (NodeData.DataType = GrtMtFunction) then
    begin
      ParentNodeData := ModulesTree.GetNodeData(
        ModulesTree.FocusedNode.Parent);

      Cmd := CommandLineUCC.ConsoleCommand;
      if (Copy(Cmd, Length(Cmd)-1, 2) = #13#10) then
        Cmd := Copy(Cmd, 1, Length(Cmd)-2);

      Cmd := Cmd +
        ParentNodeData.Module.name + ':' +
        NodeData.ModuleFunction.name + '(';

      CommandLineUCC.ConsoleCommand := Cmd;
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

begin
  CommandLineUCC.SetFocus;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);

var
  NodeData1,
    NodeData2: FGrtModuleTreeData;

begin
  NodeData1 := Sender.GetNodeData(Node1);
  NodeData2 := Sender.GetNodeData(Node2);

  if (NodeData1.DataType = GrtMtModule) and
    (NodeData2.DataType = GrtMtModule) then
    Result := CompareText(NodeData1.Module.name, NodeData2.Module.name);
end;


// -----------------------------------------------------------------------------

procedure TXGrtShellForm.FontSizeMIClick(Sender: TObject);

var
  NewFontHeight: Integer;

begin
  if (Sender is TTntMenuItem) then
  begin
    TTntMenuItem(Sender).Checked := True;

    NewFontHeight := TTntMenuItem(Sender).Tag * -1;

    if (NewFontHeight<=-10) then
      CommandLineUCC.Font.Height := NewFontHeight;

    if (NewFontHeight<=-11) then
      CommandLineUCC.Font.Style := [fsBold]
    else
      CommandLineUCC.Font.Style := [];
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ModulesTreeChange(Sender: TBaseVirtualTree;
  Node: PVirtualNode);

var
  NodeData: FGrtModuleTreeData;
  Module: PMYX_GRT_MODULE;

begin
  if (Node<>nil) then
  begin
    NodeData := Sender.GetNodeData(Node);

    if (NodeData.DataType = GrtMtModule) then
      Module := NodeData.Module
    else
      Module := NodeData.ModuleFunction.module;

    ModuleNameLbl.Caption := Module.name;
    PathLbl.Caption := Module.path;
    ExtendsLbl.Caption := Module.extends;
    case myx_grt_module_get_type(Module) of
      MYX_BUILTIN_MODULE_TYPE:
        ModuleTypeLbl.Caption := 'C Module';
      MYX_JAVA_MODULE_TYPE:
        ModuleTypeLbl.Caption := 'Java Module';
      MYX_LUA_MODULE_TYPE:
        ModuleTypeLbl.Caption := 'Lua Module';
      MYX_PYTHON_MODULE_TYPE:
        ModuleTypeLbl.Caption := 'Python Module';
    else
      ModuleTypeLbl.Caption := '-';
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.BuildStructsTree;

begin
  if (FGrt=nil) then
    Exit;

  StructsTree.BeginUpdate;
  try
    StructsTree.Clear;
    StructsTree.NodeDataSize:=sizeof(TGRTStructTreeData);

    if (SortStructsBy = GrtStSTHierachy) then
      StructsTree.RootNodeCount := myx_grt_struct_get_child_count(FGrt.PGrt, '')
    else
      if (SortStructsBy = GrtStSTName) then
        StructsTree.RootNodeCount := myx_grt_struct_get_count(FGrt.PGrt)
      else
        if (SortStructsBy = GrtStSTPackage) then
          StructsTree.RootNodeCount := myx_grt_package_count(FGrt.PGrt)
  finally
    StructsTree.EndUpdate;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsTreeAfterCellPaint(Sender: TBaseVirtualTree;
  TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  CellRect: TRect);
  
var
  NodeData: FGrtStructTreeData;
  TxtRect: TRect;
  x: integer;
  Icon: TPNGObject;

begin
  if(Column=0)then
  begin
    NodeData := Sender.GetNodeData(Node);

    TxtRect:=Sender.GetDisplayRect(Node, Column, True);
    x:=TxtRect.Left-Sender.OffsetX;

    //Draw > / v
    if (Node.ChildCount>0) or (vsHasChildren in Node.States) then
    begin
      if(Sender.Expanded[Node])then
        FTreeBtnOpenPNGImg.Draw(TargetCanvas,
          Rect(x-16-12, CellRect.Top+4, x-16-4, CellRect.Top+16+4))
      else
        FTreeBtnClosedPNGImg.Draw(TargetCanvas,
          Rect(x-16-12, CellRect.Top+4, x-16-4, CellRect.Top+16+4))
    end;

    if (NodeData.DataType = GrtStStruct) then
      Icon := FGrtValueStructPNGImg
    else
      Icon := FGrtValueSimplePNGImg;

    Icon.Draw(TargetCanvas,
      Rect(x-16, CellRect.Top+1, x, CellRect.Top+1+16));
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsTreeInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);

var
  NodeData, ParentNodeData: FGrtStructTreeData;
  ParentName: WideString;

begin
  NodeData := Sender.GetNodeData(Node);

  if (SortStructsBy = GrtStSTHierachy) then
  begin
    NodeData.DataType := GrtStStruct;

    if (ParentNode = nil) then
    begin
      NodeData.Struct := myx_grt_struct_get_child_by_index(
        FGrt.PGrt, '', Node.Index);

      if (myx_grt_struct_get_child_count(FGrt.PGrt, '')>0) then
        Include(InitialStates, ivsHasChildren);
    end
    else
    begin
      ParentNodeData := Sender.GetNodeData(ParentNode);

      if (ParentNodeData.DataType = GrtStStruct) then
      begin
        ParentName := Utf8Decode(
          _myx_grt_struct_get_name(ParentNodeData.Struct));

        NodeData.Struct := myx_grt_struct_get_child_by_index(
          FGrt.PGrt, ParentName, Node.Index);

        if (myx_grt_struct_get_child_count(FGrt.PGrt, ParentName)>0) then
          Include(InitialStates, ivsHasChildren);
      end;
    end;
  end
  else
    if (SortStructsBy = GrtStSTName) then
    begin
      if (ParentNode = nil) then
      begin
        NodeData.DataType := GrtStStruct;
        NodeData.Struct := myx_grt_struct_get_by_index(FGrt.PGrt, Node.Index);

        Include(InitialStates, ivsHasChildren);
      end
      else
      begin
        ParentNodeData := Sender.GetNodeData(ParentNode);

        if (ParentNodeData.DataType = GrtStStruct) then
        begin
          NodeData.DataType := GrtStMember;
          NodeData.Member := myx_grt_struct_get_member_by_index(
            ParentNodeData.Struct, Node.Index);
        end;
      end;
    end
    else
      if (SortStructsBy = GrtStSTPackage) then
      begin
        if (ParentNode = nil) then
        begin
          NodeData.DataType := GrtStPackage;
          NodeData.PackageName := myx_grt_package_by_index(FGrt.PGrt, Node.Index);

          Include(InitialStates, ivsHasChildren);
        end
        else
        begin
          ParentNodeData := Sender.GetNodeData(ParentNode);

          if (ParentNodeData.DataType = GrtStPackage) then
          begin
            NodeData.DataType := GrtStStruct;
            NodeData.Struct := myx_grt_package_struct_by_index(
              FGrt.PGrt, ParentNodeData.PackageName, Node.Index);

            if (myx_grt_struct_get_member_count(NodeData.Struct)>0) then
              Include(InitialStates, ivsHasChildren);
          end
          else
            if (ParentNodeData.DataType = GrtStStruct) then
            begin
              NodeData.DataType := GrtStMember;
              NodeData.Member := myx_grt_struct_get_member_by_index(
                ParentNodeData.Struct, Node.Index);
            end;
        end;
      end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsTreeInitChildren(Sender: TBaseVirtualTree;
  Node: PVirtualNode; var ChildCount: Cardinal);

var
  NodeData: FGrtStructTreeData;
  Name: WideString;

begin
  NodeData := Sender.GetNodeData(Node);

  if (SortStructsBy = GrtStSTHierachy) then
  begin
    Name := Utf8Decode(_myx_grt_struct_get_name(NodeData.Struct));
    ChildCount := myx_grt_struct_get_child_count(FGrt.PGrt, Name);
  end
  else
    if (SortStructsBy = GrtStSTName) then
    begin
      if (NodeData.DataType = GrtStStruct) then
        ChildCount := myx_grt_struct_get_member_count(NodeData.Struct)
      else
        ChildCount := 0;
    end
    else
      if (SortStructsBy = GrtStSTPackage) then
      begin
        if (NodeData.DataType = GrtStPackage) then
          ChildCount := myx_grt_package_struct_count(FGrt.PGrt, NodeData.PackageName)
        else
          if (NodeData.DataType = GrtStStruct) then
            ChildCount := myx_grt_struct_get_member_count(NodeData.Struct)
          else
            ChildCount := 0;
      end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsTreeGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);

var
  NodeData: FGrtStructTreeData;
  InheritedCaption: Integer;

begin
  NodeData := Sender.GetNodeData(Node);

  if (NodeData.DataType = GrtStPackage) then
  begin
    if (TextType = ttNormal) then
    begin
      if (NodeData.PackageName<>'') then
        CellText := NodeData.PackageName
      else
        CellText := '<base>';
    end;
  end
  else
    if (NodeData.DataType = GrtStStruct) then
    begin
      if (TextType = ttNormal) then
        CellText := Utf8Decode(_myx_grt_struct_get_name(NodeData.Struct))
      else
      begin
        CellText := Utf8Decode(_myx_grt_struct_get_caption(FGrt.PGrt, NodeData.Struct, @InheritedCaption));
        if (CellText<>'') and (InheritedCaption=1) then
          CellText := '<<' + CellText + '>>'
        else
          CellText := '(' + CellText + ')';
      end;
    end
    else
    begin
      if (TextType = ttNormal) then
        CellText :=
          Utf8Decode(_myx_grt_struct_get_member_name(NodeData.Member)) +
          ': ' + Utf8Decode(_myx_get_value_type_as_string(
            myx_grt_struct_member_get_type(NodeData.Member))) + ';'
      else
        CellText := Utf8Decode(_myx_grt_struct_get_member_desc(NodeData.Member));
    end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ObjectTreeLookupCloseUp(Sender: TObject);

begin
  BuildObjTreeFromLookupSelection;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ObjectTreeLookupKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);

var
  Index: Integer;

begin
  if (Key = VK_RETURN) then
  begin
    Index := ObjectTreeLookup.Items.IndexOf(ObjectTreeLookup.Text);
    if (Index = -1) then
      Index := ObjectTreeLookup.Items.Add(ObjectTreeLookup.Text);

    ObjectTreeLookup.ItemIndex := Index;
    BuildObjTreeFromLookupSelection;

    GRTObjTreeChange(GRTObjectTree, GRTObjectTree.GetFirst);

    Key := 0;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsTreeCompareNodes(Sender: TBaseVirtualTree;
  Node1, Node2: PVirtualNode; Column: TColumnIndex; var Result: Integer);

var
  NodeData1, NodeData2: FGrtStructTreeData;
  DotCount1, DotCount2: Integer;
  Name1, Name2: WideString;

begin
  NodeData1 := Sender.GetNodeData(Node1);
  NodeData2 := Sender.GetNodeData(Node2);

  if (NodeData1.DataType=GrtStPackage) and
    (NodeData2.DataType=GrtStPackage) then
  begin
    DotCount1 := GetSubstringCount('.', NodeData1.PackageName);
    DotCount2 := GetSubstringCount('.', NodeData2.PackageName);

    if (DotCount1<>DotCount2) then
      Result := DotCount1-DotCount2
    else
      Result := WideCompareText(NodeData1.PackageName,
        NodeData2.PackageName);
  end
  else
    if (NodeData1.DataType=GrtStStruct) and
      (NodeData2.DataType=GrtStStruct) then
    begin
      Name1 := Utf8Decode(_myx_grt_struct_get_name(NodeData1.Struct));
      Name2 := Utf8Decode(_myx_grt_struct_get_name(NodeData2.Struct));

      DotCount1 := GetSubstringCount('.', Name1);
      DotCount2 := GetSubstringCount('.', Name2);

      if (DotCount1<>DotCount2) then
        Result := DotCount1-DotCount2
      else
        Result := WideCompareText(Name1, Name2);
    end
    else
      if (NodeData1.DataType=GrtStMember) and
        (NodeData2.DataType=GrtStMember) then
      begin
        Name1 := Utf8Decode(_myx_grt_struct_get_member_name(NodeData1.Member));
        Name2 := Utf8Decode(_myx_grt_struct_get_member_name(NodeData2.Member));

        Result := WideCompareText(Name1, Name2);
      end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.SetSortStructsBy(SortStructsBy: GrtStructSortType);

begin
  if (FSortStructsBy<>SortStructsBy) then
  begin
    FSortStructsBy := SortStructsBy;

    BuildStructsTree;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsOrderbyNameMIClick(Sender: TObject);

begin
  SortStructsBy := GrtStSTName;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsOrderbyHierachyMIClick(Sender: TObject);

begin
  SortStructsBy := GrtStSTHierachy;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsOrderbyPackagesMIClick(Sender: TObject);

begin
  SortStructsBy := GrtStSTPackage;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructPopupMenuPopup(Sender: TObject);

begin
  if (SortStructsBy = GrtStSTHierachy) then
    StructsOrderbyHierachyMI.Checked := True
  else
    if (SortStructsBy = GrtStSTName) then
      StructsOrderbyNameMI.Checked := True
    else
      if (SortStructsBy = GrtStSTPackage) then
        StructsOrderbyPackagesMI.Checked := True;

end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.StructsTreeGetHint(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex;
  var LineBreakStyle: TVTTooltipLineBreakStyle; var HintText: WideString);

var
  NodeData: FGrtStructTreeData;

begin
  NodeData := Sender.GetNodeData(Node);

  if (NodeData.DataType = GrtStStruct) then
    HintText := Utf8Decode(_myx_grt_struct_get_desc(FGrt.PGrt, NodeData.Struct))
  else if (NodeData.DataType = GrtStMember) then
    HintText := Utf8Decode(_myx_grt_struct_get_member_desc(NodeData.Member));
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.CommandLineUCCDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);

begin
  if (Source = GRTObjectTree) then
    Accept := True
  else
    Accept := False;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.CommandLineUCCDragDrop(Sender, Source: TObject; X,
  Y: Integer);

var
  Node: PVirtualNode;
  NodeData: PGrtObjTreeData;
  Path,
    Cmd: WideString;

begin
  if (Source = GRTObjectTree) then
  begin
    Node := GRTObjectTree.FocusedNode;
    NodeData := GRTObjectTree.GetNodeData(Node);

    Path := NodeData.Key;
    while (Node.Parent<>GRTObjectTree.GetFirst) do
    begin
      Node := Node.Parent;
      NodeData := GRTObjectTree.GetNodeData(Node);

      if (NodeData <> nil) then
        Path := NodeData.Key + '/' + Path;
    end;
    Path := '/' + Path;

    Cmd := CommandLineUCC.ConsoleCommand;
    if (Copy(Cmd, Length(Cmd)-1, 2) = #13#10) then
      Cmd := Copy(Cmd, 1, Length(Cmd)-2);

    Cmd := Cmd +
      'getobj("'+Path+'")';

    CommandLineUCC.ConsoleCommand := Cmd;

    CommandLineUCC.SetFocus;
  end;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.ObjInspectorCopyValueMIClick(Sender: TObject);

begin
  if (ObjInspectorTree.FocusedNode<>nil) then
    TntClipboard.AsWideText :=
      GetInspectorObjectText(ObjInspectorTree.FocusedNode,
        ObjInspectorTree.FocusedColumn);
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.CurrentReverenceValuesMIClick(Sender: TObject);

begin
  CurrentReverenceValuesMI.Checked := Not(CurrentReverenceValuesMI.Checked);
  GRTObjectTree.Invalidate;
end;

// -----------------------------------------------------------------------------

procedure TXGrtShellForm.RemoveObjectMIClick(Sender: TObject);

var
  NodeData,
    ParentNodeData: PGrtObjTreeData;

begin
  if (GRTObjectTree.FocusedNode <> nil) and
    (GRTObjectTree.FocusedNode <> GRTObjectTree.GetFirst) then
  begin
    NodeData := GRTObjectTree.GetNodeData(GRTObjectTree.FocusedNode);
    ParentNodeData := GRTObjectTree.GetNodeData(GRTObjectTree.FocusedNode.Parent);

    if (ParentNodeData.ValueType = MYX_DICT_VALUE) then
    begin
      myx_grt_dict_item_del(ParentNodeData.Value,
        NodeData.Key);
    end
    else
      if (ParentNodeData.ValueType = MYX_LIST_VALUE) then
      begin
        myx_grt_list_item_del(ParentNodeData.Value,
          GRTObjectTree.FocusedNode.Index);
      end;

    RefreshMIClick(self);
  end;
end;

end.
